--- old/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
+++ new/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
@@ -955,7 +1540,226 @@
 	return (qlt_setup_fixed(qlt));
 }
 
+static uint8_t *
+qlt_vpd_findtag(qlt_state_t *qlt, uint8_t *vpdbuf, int8_t *opcode)
+{
+	uint8_t	*vpd = vpdbuf;
+	uint8_t	*end = vpdbuf + QL_24XX_VPD_SIZE;
+	uint32_t found = 0;
+
+	if (vpdbuf == NULL || opcode == NULL) {
+		EL(qlt, "null parameter passed!\n");
+		return (NULL);
+	}
+
+	while (vpd < end) {
+		if (vpd[0] == VPD_TAG_END) {
+			if (opcode[0] == VPD_TAG_END) {
+				found = 1;
+			} else {
+				found = 0;
+			}
+			break;
+		}
+
+		if (bcmp(opcode, vpd, strlen(opcode)) == 0) {
+			found = 1;
+			break;
+		}
+
+		if (!(strncmp((char *)vpd, (char *)VPD_TAG_PRODID, 1))) {
+			vpd += (vpd[2] << 8) + vpd[1] + 3;
+		} else if (*vpd == VPD_TAG_LRT || *vpd == VPD_TAG_LRTC) {
+			vpd += 3;
+		} else {
+			vpd += vpd[2] +3;
+		}
+	}
+	return (found == 1 ? vpd : NULL);
+}
+
 /*
+ * qlt_vpd_lookup
+ *      Return the VPD data for the request VPD tag
+ *
+ * Input:
+ *      qlt      = adapter state pointer.
+ *      opcode  = VPD opcode to find (must be NULL terminated).
+ *      bp      = Pointer to returned data buffer.
+ *      bplen   = Length of returned data buffer.
+ *
+ * Returns:
+ *      Length of data copied into returned data buffer.
+ *              >0 = VPD data field (NULL terminated)
+ *               0 = no data.
+ *              -1 = Could not find opcode in vpd buffer / error.
+ *
+ * Context:
+ *      Kernel context.
+ *
+ * NB: The opcode buffer and the bp buffer *could* be the same buffer!
+ *
+ */
+static int
+qlt_vpd_lookup(qlt_state_t *qlt, uint8_t *opcode, uint8_t *bp,
+    int32_t bplen)
+{
+	uint8_t	*vpd = NULL;
+	uint8_t	*vpdbuf = NULL;
+	int32_t	len = -1;
+
+	if (opcode == NULL || bp == NULL || bplen < 1) {
+		EL(qlt, "invalid parameter passed: opcode=%ph, "
+		    "bp=%ph, bplen=%xh\n", opcode, bp, bplen);
+		return (len);
+	}
+
+	vpdbuf = (uint8_t *)qlt->vpd;
+	if ((vpd = qlt_vpd_findtag(qlt, vpdbuf, (int8_t *)opcode)) != NULL) {
+		/*
+		 * Found the tag
+		 */
+		if (*opcode == VPD_TAG_END || *opcode == VPD_TAG_LRT ||
+		    *opcode == VPD_TAG_LRTC) {
+			/*
+			 * We found it, but the tag doesn't have a data
+			 * field.
+			 */
+			len = 0;
+		} else if (!(strncmp((char *)vpd, (char *)
+		    VPD_TAG_PRODID, 1))) {
+			len = vpd[2] << 8;
+			len += vpd[1];
+		} else {
+			len = vpd[2];
+		}
+
+		/*
+		 * Make sure that the vpd len does not exceed the
+		 * vpd end
+		 */
+		if (vpd+len > vpdbuf + QL_24XX_VPD_SIZE) {
+			EL(qlt, "vpd tag len (%xh) exceeds vpd buffer "
+			    "length\n", len);
+			len = -1;
+		}
+	} else {
+		EL(qlt, "Cna't find vpd tag \n");
+		return (-1);
+	}
+
+	if (len >= 0) {
+		/*
+		 * make sure we don't exceed callers buffer space len
+		 */
+		if (len > bplen) {
+			len = bplen - 1;
+		}
+		/* copy the data back */
+		(void) strncpy((int8_t *)bp, (int8_t *)(vpd+3), (int64_t)len);
+		bp[len] = NULL;
+	} else {
+		/* error -- couldn't find tag */
+		bp[0] = NULL;
+		if (opcode[1] != NULL) {
+			EL(qlt, "unable to find tag '%s'\n", opcode);
+		} else {
+			EL(qlt, "unable to find tag '%xh'\n", opcode[0]);
+		}
+	}
+	return (len);
+}
+
+void
+qlt_get_rom_version(qlt_state_t *qlt, caddr_t orv)
+{
+	int i;
+	char bios0_str[32];
+	char fcode_str[32];
+	char efi_str[32];
+	char hppa_str[32];
+	char tmp[80];
+	uint32_t bios_cnt = 0;
+	uint32_t fcode_cnt = 0;
+	boolean_t last_image = FALSE;
+
+	/* collect right rom_version from image[] */
+	i = 0;
+	do {
+		if (qlt->rimage[0].header.signature[0] != PCI_HEADER0) {
+			break;
+		}
+
+		if (qlt->rimage[i].data.codetype == PCI_CODE_X86PC) {
+			/* BIOS */
+			if (bios_cnt == 0) {
+				(void) snprintf(bios0_str,
+				    32,
+				    "%d.%02d",
+				    qlt->rimage[i].data.
+				    revisionlevel[1],
+				    qlt->rimage[i].data.
+				    revisionlevel[0]);
+				(void) snprintf(tmp, 80,
+				    " BIOS: %s;", bios0_str);
+				(void) strcat(orv, tmp);
+			}
+			bios_cnt++;
+		} else if (qlt->rimage[i].data.codetype == PCI_CODE_FCODE) {
+			/* FCode */
+			if (fcode_cnt == 0) {
+				(void) snprintf(fcode_str,
+				    32,
+				    "%d.%02d",
+				    qlt->rimage[i].data.revisionlevel[1],
+				    qlt->rimage[i].data.revisionlevel[0]);
+				(void) snprintf(tmp, 80,
+				    " FCode: %s;", fcode_str);
+				(void) strcat(orv, tmp);
+			}
+			fcode_cnt++;
+		} else if (qlt->rimage[i].data.codetype == PCI_CODE_EFI) {
+			/* EFI */
+			(void) snprintf(efi_str,
+			    32,
+			    "%d.%02d",
+			    qlt->rimage[i].data.revisionlevel[1],
+			    qlt->rimage[i].data.revisionlevel[0]);
+			(void) snprintf(tmp, 80, " EFI: %s;", efi_str);
+			(void) strcat(orv, tmp);
+		} else if (qlt->rimage[i].data.codetype == PCI_CODE_HPPA) {
+			/* HPPA */
+			(void) snprintf(hppa_str,
+			    32,
+			    "%d.%02d",
+			    qlt->rimage[i].data.revisionlevel[1],
+			    qlt->rimage[i].data.revisionlevel[0]);
+			(void) snprintf(orv, 80, " HPPA: %s;", hppa_str);
+			(void) strcat(orv, tmp);
+		} else if (qlt->rimage[i].data.codetype == PCI_CODE_FW) {
+			EL(qlt, "fw infor skip\n");
+		} else {
+			/* Unknown */
+			EL(qlt, "unknown image\n");
+			break;
+		}
+
+		if (qlt->rimage[i].data.indicator == PCI_IND_LAST_IMAGE) {
+			last_image = TRUE;
+			break;
+		}
+
+		i ++;
+	} while ((last_image != TRUE) && (i < 6));
+
+	if (last_image != TRUE) {
+		/* No boot image detected */
+		(void) snprintf(orv, FCHBA_OPTION_ROM_VERSION_LEN, "%s",
+		    "No boot image detected");
+	}
+}
+
+/*
  * Filling the hba attributes
  */
 void
@@ -962,7 +1766,6 @@
 qlt_populate_hba_fru_details(struct fct_local_port *port,
     struct fct_port_attrs *port_attrs)
 {
-	caddr_t	bufp;
 	int len;
 	qlt_state_t *qlt = (qlt_state_t *)port->port_fca_private;
 
@@ -972,7 +1775,11 @@
 	    "%s", QLT_NAME);
 	(void) snprintf(port_attrs->driver_version, FCHBA_DRIVER_VERSION_LEN,
 	    "%s", QLT_VERSION);
-	port_attrs->serial_number[0] = '\0';
+	/* get serial_number from vpd data */
+	if (qlt_vpd_lookup(qlt, (uint8_t *)VPD_TAG_SN, (uint8_t *)
+	    port_attrs->serial_number, FCHBA_SERIAL_NUMBER_LEN) == -1) {
+			port_attrs->serial_number[0] = '\0';
+	}
 	port_attrs->hardware_version[0] = '\0';
 
 	(void) snprintf(port_attrs->firmware_version,
@@ -980,22 +1787,8 @@
 	    qlt->fw_minor, qlt->fw_subminor);
 
 	/* Get FCode version */
-	if (ddi_getlongprop(DDI_DEV_T_ANY, qlt->dip, PROP_LEN_AND_VAL_ALLOC |
-	    DDI_PROP_DONTPASS | DDI_PROP_CANSLEEP, "version", (caddr_t)&bufp,
-	    (int *)&len) == DDI_PROP_SUCCESS) {
-		(void) snprintf(port_attrs->option_rom_version,
-		    FCHBA_OPTION_ROM_VERSION_LEN, "%s", bufp);
-		kmem_free(bufp, (uint_t)len);
-		bufp = NULL;
-	} else {
-#ifdef __sparc
-		(void) snprintf(port_attrs->option_rom_version,
-		    FCHBA_OPTION_ROM_VERSION_LEN, "No Fcode found");
-#else
-		(void) snprintf(port_attrs->option_rom_version,
-		    FCHBA_OPTION_ROM_VERSION_LEN, "N/A");
-#endif
-	}
+	qlt_get_rom_version(qlt, (caddr_t)&port_attrs->option_rom_version[0]);
+
 	port_attrs->vendor_specific_id = qlt->nvram->subsystem_vendor_id[0] |
 	    qlt->nvram->subsystem_vendor_id[1] << 8;
 
@@ -1003,16 +1796,31 @@
 	    qlt->nvram->max_frame_length[0];
 
 	port_attrs->supported_cos = 0x10000000;
-	port_attrs->supported_speed = PORT_SPEED_1G |
-	    PORT_SPEED_2G | PORT_SPEED_4G;
-	if (qlt->qlt_25xx_chip)
+
+	if (qlt->qlt_fcoe_enabled) {
+		port_attrs->supported_speed = PORT_SPEED_10G;
+	} else if (qlt->qlt_27xx_chip) {
+		if ((qlt->qlt_27xx_speed & MAX_SPEED_MASK) == MAX_SPEED_32G) {
+			port_attrs->supported_speed = PORT_SPEED_8G |
+			    PORT_SPEED_16G | PORT_SPEED_32G;
+		} else {
+			port_attrs->supported_speed = PORT_SPEED_4G |
+			    PORT_SPEED_8G | PORT_SPEED_16G;
+		}
+	} else if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		port_attrs->supported_speed = PORT_SPEED_4G |
+		    PORT_SPEED_8G | PORT_SPEED_16G;
+	} else if (qlt->qlt_25xx_chip) {
 		port_attrs->supported_speed = PORT_SPEED_2G | PORT_SPEED_4G |
 		    PORT_SPEED_8G;
-	if (qlt->qlt_81xx_chip)
-		port_attrs->supported_speed = PORT_SPEED_10G;
+	} else {
+		port_attrs->supported_speed = PORT_SPEED_1G |
+		    PORT_SPEED_2G | PORT_SPEED_4G;
+	}
 
 	/* limit string length to nvr model_name length */
-	len = (qlt->qlt_81xx_chip) ? 16 : 8;
+	len = ((qlt->qlt_81xx_chip) || (qlt->qlt_83xx_chip) ||
+	    (qlt->qlt_27xx_chip)) ? 16 : 8;
 	(void) snprintf(port_attrs->model,
 	    (uint_t)(len < FCHBA_MODEL_LEN ? len : FCHBA_MODEL_LEN),
 	    "%s", qlt->nvram->model_name);
@@ -1036,6 +1844,9 @@
 
 	switch (cmd) {
 	case FC_TGT_PORT_RLS:
+		if (qlt->qlt_state != FCT_STATE_ONLINE) {
+			break;
+		}
 		if ((*bufsizep) < sizeof (fct_port_link_status_t)) {
 			EL(qlt, "FC_TGT_PORT_RLS bufsizep=%xh < "
 			    "fct_port_link_status_t=%xh\n", *bufsizep,
@@ -1059,7 +1870,7 @@
 
 		ret = qlt_mailbox_command(qlt, mcp);
 		if (ret != QLT_SUCCESS) {
-			EL(qlt, "qlt_mailbox_command=6dh status=%llxh\n", ret);
+			EL(qlt, "qlt_mbox_command=6dh status=%llxh\n", ret);
 			qlt_free_mailbox_command(qlt, mcp);
 			break;
 		}
@@ -1098,6 +1909,7 @@
 	if (qlt_dmem_init(qlt) != QLT_SUCCESS) {
 		return (FCT_FAILURE);
 	}
+
 	/* Initialize the ddi_dma_handle free pool */
 	qlt_dma_handle_pool_init(qlt);
 
@@ -1115,7 +1927,7 @@
 	fds->fds_setup_dbuf = qlt_dma_setup_dbuf;
 	fds->fds_teardown_dbuf = qlt_dma_teardown_dbuf;
 	fds->fds_max_sgl_xfer_len = QLT_DMA_SG_LIST_LENGTH * MMU_PAGESIZE;
-	fds->fds_copy_threshold = MMU_PAGESIZE;
+	fds->fds_copy_threshold = (uint32_t)MMU_PAGESIZE;
 	fds->fds_fca_private = (void *)qlt;
 	/*
 	 * Since we keep everything in the state struct and dont allocate any
@@ -1155,6 +1967,27 @@
 		goto qlt_pstart_fail_2_5;
 	}
 
+	EL(qlt, "Qlogic qlt(%d) "
+	    "WWPN=%02x%02x%02x%02x%02x%02x%02x%02x:"
+	    "WWNN=%02x%02x%02x%02x%02x%02x%02x%02x\n",
+	    qlt->instance,
+	    qlt->nvram->port_name[0],
+	    qlt->nvram->port_name[1],
+	    qlt->nvram->port_name[2],
+	    qlt->nvram->port_name[3],
+	    qlt->nvram->port_name[4],
+	    qlt->nvram->port_name[5],
+	    qlt->nvram->port_name[6],
+	    qlt->nvram->port_name[7],
+	    qlt->nvram->node_name[0],
+	    qlt->nvram->node_name[1],
+	    qlt->nvram->node_name[2],
+	    qlt->nvram->node_name[3],
+	    qlt->nvram->node_name[4],
+	    qlt->nvram->node_name[5],
+	    qlt->nvram->node_name[6],
+	    qlt->nvram->node_name[7]);
+
 	return (QLT_SUCCESS);
 #if 0
 qlt_pstart_fail_3:
@@ -1183,8 +2016,8 @@
 	}
 	fct_free(qlt->qlt_port->port_fds);
 	fct_free(qlt->qlt_port);
-	qlt->qlt_port = NULL;
 	qlt_dma_handle_pool_fini(qlt);
+	qlt->qlt_port = NULL;
 	qlt_dmem_fini(qlt);
 	return (QLT_SUCCESS);
 }
@@ -1198,7 +2031,7 @@
 qlt_port_online(qlt_state_t *qlt)
 {
 	uint64_t	da;
-	int		instance, i;
+	int		instance, i, j;
 	fct_status_t	ret;
 	uint16_t	rcount;
 	caddr_t		icb;
@@ -1210,7 +2043,8 @@
 	/* XXX Make sure a sane state */
 
 	if ((ret = qlt_download_fw(qlt)) != QLT_SUCCESS) {
-		cmn_err(CE_NOTE, "reset chip failed %llx", (long long)ret);
+		cmn_err(CE_NOTE, "qlt(%d): reset chip failed %llx",
+		    qlt->instance, (long long)ret);
 		return (ret);
 	}
 
@@ -1253,7 +2087,7 @@
 	SETELSBIT(elsbmp, ELS_OP_PLOGI);
 	SETELSBIT(elsbmp, ELS_OP_LOGO);
 	SETELSBIT(elsbmp, ELS_OP_ABTX);
-	SETELSBIT(elsbmp, ELS_OP_ECHO);
+/*	SETELSBIT(elsbmp, ELS_OP_ECHO); till fct handles it */
 	SETELSBIT(elsbmp, ELS_OP_PRLI);
 	SETELSBIT(elsbmp, ELS_OP_PRLO);
 	SETELSBIT(elsbmp, ELS_OP_SCN);
@@ -1275,17 +2109,66 @@
 	}
 
 	/* Init queue pointers */
-	REG_WR32(qlt, REG_REQ_IN_PTR, 0);
-	REG_WR32(qlt, REG_REQ_OUT_PTR, 0);
-	REG_WR32(qlt, REG_RESP_IN_PTR, 0);
-	REG_WR32(qlt, REG_RESP_OUT_PTR, 0);
-	REG_WR32(qlt, REG_PREQ_IN_PTR, 0);
-	REG_WR32(qlt, REG_PREQ_OUT_PTR, 0);
-	REG_WR32(qlt, REG_ATIO_IN_PTR, 0);
-	REG_WR32(qlt, REG_ATIO_OUT_PTR, 0);
-	qlt->req_ndx_to_fw = qlt->req_ndx_from_fw = 0;
-	qlt->req_available = REQUEST_QUEUE_ENTRIES - 1;
-	qlt->resp_ndx_to_fw = qlt->resp_ndx_from_fw = 0;
+	if (qlt->qlt_mq_enabled == 1) {
+		uint16_t qi;
+
+		for (qi = 0; qi < MQ_MAX_QUEUES; qi++) {
+			MQBAR_WR32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_REQ_IN, 0);
+			MQBAR_WR32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_REQ_OUT, 0);
+			MQBAR_WR32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_IN, 0);
+			MQBAR_WR32(qlt,
+			    (qi * MQBAR_REG_OFFSET) +
+			    MQBAR_RESP_OUT, 0);
+		}
+	} else {
+		REG_WR32(qlt, REG_REQ_IN_PTR, 0);
+		REG_WR32(qlt, REG_REQ_OUT_PTR, 0);
+		REG_WR32(qlt, REG_RESP_IN_PTR, 0);
+		REG_WR32(qlt, REG_RESP_OUT_PTR, 0);
+	}
+
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		REG_WR32(qlt, REG_PREQ_IN_PTR, 0);
+		REG_WR32(qlt, REG_PREQ_OUT_PTR, 0);
+		REG_WR32(qlt, REG_ATIO_IN_PTR, 0);
+		REG_WR32(qlt, REG_ATIO_OUT_PTR, 0);
+	}
+	qlt->mq_req[0].mq_ndx_to_fw = qlt->mq_req[0].mq_ndx_from_fw = 0;
+	qlt->mq_req[0].mq_available = REQUEST_QUEUE_ENTRIES - 1;
+
+	if (qlt->qlt_mq_enabled == 1) {
+		for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+			qlt->mq_req[i].mq_ndx_to_fw = 0;
+			qlt->mq_req[i].mq_ndx_from_fw = 0;
+			qlt->mq_req[i].mq_available =
+			    REQUEST_QUEUE_MQ_ENTRIES - 1;
+		}
+	}
+	qlt->mq_resp[0].mq_ndx_to_fw = qlt->mq_resp[0].mq_ndx_from_fw = 0;
+
+	if (qlt->qlt_mq_enabled == 1) {
+		caddr_t resp;
+
+		for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+			qlt->mq_resp[i].mq_ndx_to_fw = 0;
+			qlt->mq_resp[i].mq_ndx_from_fw = 0;
+			for (j = 0; j < RESPONSE_QUEUE_MQ_ENTRIES; j++) {
+				resp = &qlt->mq_resp[i].mq_ptr[j << 6];
+				QMEM_WR32_RSPQ(qlt, i, resp+0x3c, 0xdeadbeef);
+			}
+		}
+	}
+
+	for (i = 0; i < ATIO_QUEUE_ENTRIES; i++) {
+		caddr_t atio;
+
+		atio = &qlt->atio_ptr[i << 6];
+		QMEM_WR32(qlt, atio+0x3c, 0xdeadbeef);
+	}
+
 	qlt->preq_ndx_to_fw = qlt->preq_ndx_from_fw = 0;
 	qlt->atio_ndx_to_fw = qlt->atio_ndx_from_fw = 0;
 
@@ -1292,9 +2175,14 @@
 	/*
 	 * XXX support for tunables. Also should we cache icb ?
 	 */
-	if (qlt->qlt_81xx_chip) {
-	    /* allocate extra 64 bytes for Extended init control block */
-		mcp = qlt_alloc_mailbox_command(qlt, 0xC0);
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_27xx_chip) || ((qlt->qlt_25xx_chip) &&
+	    (qlt->qlt_mq_enabled))) {
+		/*
+		 * allocate extra 64 bytes for Extended init control block,
+		 * with separation to allow for a minimal MID section.
+		 */
+		mcp = qlt_alloc_mailbox_command(qlt, 0xE0);
 	} else {
 		mcp = qlt_alloc_mailbox_command(qlt, 0x80);
 	}
@@ -1303,8 +2191,10 @@
 		return (STMF_ALLOC_FAILURE);
 	}
 	icb = (caddr_t)mcp->dbuf->db_sglist[0].seg_addr;
-	if (qlt->qlt_81xx_chip) {
-		bzero(icb, 0xC0);
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_27xx_chip) || ((qlt->qlt_25xx_chip) &&
+	    (qlt->qlt_mq_enabled))) {
+		bzero(icb, 0xE0);
 	} else {
 		bzero(icb, 0x80);
 	}
@@ -1319,22 +2209,63 @@
 	DMEM_WR16(qlt, icb+0x20, 3);	/* Login retry count */
 	DMEM_WR16(qlt, icb+0x24, RESPONSE_QUEUE_ENTRIES);
 	DMEM_WR16(qlt, icb+0x26, REQUEST_QUEUE_ENTRIES);
-	if (!qlt->qlt_81xx_chip) {
+	if ((!qlt->qlt_83xx_chip) && (!qlt->qlt_81xx_chip) &&
+	    (!qlt->qlt_27xx_chip)) {
 		DMEM_WR16(qlt, icb+0x28, 100); /* ms of NOS/OLS for Link down */
 	}
-	DMEM_WR16(qlt, icb+0x2a, PRIORITY_QUEUE_ENTRIES);
+	if ((!qlt->qlt_83xx_chip) || (!qlt->qlt_27xx_chip)) {
+		DMEM_WR16(qlt, icb+0x2a, PRIORITY_QUEUE_ENTRIES);
+	}
 	DMEM_WR64(qlt, icb+0x2c, (da+REQUEST_QUEUE_OFFSET));
 	DMEM_WR64(qlt, icb+0x34, (da+RESPONSE_QUEUE_OFFSET));
-	DMEM_WR64(qlt, icb+0x3c, (da+PRIORITY_QUEUE_OFFSET));
+	if ((!qlt->qlt_83xx_chip) || (!qlt->qlt_27xx_chip)) {
+		DMEM_WR64(qlt, icb+0x3c, (da+PRIORITY_QUEUE_OFFSET));
+	}
+	/* XXX: all hba model atio/resp 0  use vector 0 */
 	DMEM_WR16(qlt, icb+0x4e, ATIO_QUEUE_ENTRIES);
 	DMEM_WR64(qlt, icb+0x50, (da+ATIO_QUEUE_OFFSET));
 	DMEM_WR16(qlt, icb+0x58, 2);	/* Interrupt delay Timer */
 	DMEM_WR16(qlt, icb+0x5a, 4);	/* Login timeout (secs) */
-	if (qlt->qlt_81xx_chip) {
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_27xx_chip) || ((qlt->qlt_25xx_chip) &&
+	    (qlt->qlt_mq_enabled))) {
 		qlt_nvram_81xx_t *qlt81nvr = (qlt_nvram_81xx_t *)qlt->nvram;
 
-		DMEM_WR32(qlt, icb+0x5c, BIT_5 | BIT_4); /* fw options 1 */
-		DMEM_WR32(qlt, icb+0x64, BIT_20 | BIT_4); /* fw options 3 */
+		/* fw options 1 */
+		if (qlt->qlt_fcoe_enabled) {
+			DMEM_WR32(qlt, icb+0x5c, BIT_5 | BIT_4);
+		} else {
+			DMEM_WR32(qlt, icb+0x5c,
+			    BIT_11 | BIT_5 | BIT_4 | BIT_2 | BIT_1 | BIT_0);
+		}
+		/* fw options 2 */
+		if (qlt->qlt_mq_enabled) {
+			if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+				if (qlt->qlt_fcoe_enabled) {
+					DMEM_WR32(qlt, icb+0x60,
+					    BIT_26 | BIT_23 | BIT_22);
+				} else {
+					DMEM_WR32(qlt, icb+0x60,
+					    BIT_26 | BIT_23 | BIT_22 | BIT_5);
+				}
+			} else {
+				DMEM_WR32(qlt,
+				    icb+0x60, BIT_26 | BIT_23 | BIT_22 | BIT_5);
+			}
+		}
+
+		/* fw options 3 */
+		if (qlt->qlt_fcoe_enabled) {
+			DMEM_WR32(qlt, icb+0x64, BIT_4);
+		} else {
+			DMEM_WR32(qlt, icb+0x64,
+			    BIT_14 | BIT_8 | BIT_7 | BIT_4);
+		}
+
+		if (qlt->qlt_mq_enabled) {
+			DMEM_WR16(qlt, icb+0x68, 5); /* QoS priority = 5 */
+		}
+
 		DMEM_WR32(qlt, icb+0x70,
 		    qlt81nvr->enode_mac[0] |
 		    (qlt81nvr->enode_mac[1] << 8) |
@@ -1343,15 +2274,18 @@
 		DMEM_WR16(qlt, icb+0x74,
 		    qlt81nvr->enode_mac[4] |
 		    (qlt81nvr->enode_mac[5] << 8));
-		} else {
-			DMEM_WR32(qlt, icb+0x5c, BIT_11 | BIT_5 | BIT_4 |
-			    BIT_2 | BIT_1 | BIT_0);
-			DMEM_WR32(qlt, icb+0x60, BIT_5);
-			DMEM_WR32(qlt, icb+0x64, BIT_14 | BIT_8 | BIT_7 |
-			    BIT_4);
-		}
+	} else {
+		DMEM_WR32(qlt, icb+0x5c, BIT_11 | BIT_5 | BIT_4 |
+		    BIT_2 | BIT_1 | BIT_0);
+		DMEM_WR32(qlt, icb+0x60, BIT_5);
+		DMEM_WR32(qlt, icb+0x64, BIT_14 | BIT_8 | BIT_7 |
+		    BIT_4);
 
-	if (qlt->qlt_81xx_chip) {
+/* null MID setup */
+		DMEM_WR16(qlt, icb+0x80, 1); /* VP count 1 */
+	}
+
+	if (qlt->qlt_fcoe_enabled) {
 		qlt_dmem_bctl_t		*bctl;
 		uint32_t		index;
 		caddr_t			src;
@@ -1358,16 +2292,18 @@
 		caddr_t			dst;
 		qlt_nvram_81xx_t	*qlt81nvr;
 
-		dst = icb+0x80;
+		dst = icb+0xA0;
 		qlt81nvr = (qlt_nvram_81xx_t *)qlt->nvram;
 		src = (caddr_t)&qlt81nvr->ext_blk;
 		index = sizeof (qlt_ext_icb_81xx_t);
 
 		/* Use defaults for cases where we find nothing in NVR */
-		if (*src == 0) {
-			EL(qlt, "nvram eicb=null\n");
-			cmn_err(CE_NOTE, "qlt(%d) NVR eicb is zeroed",
-			    instance);
+		if ((qlt->qlt_83xx_chip) || (*src == 0)) {
+			if (*src == 0) {
+				EL(qlt, "nvram eicb=null\n");
+				cmn_err(CE_NOTE, "qlt(%d) NVR eicb is zeroed",
+				    instance);
+			}
 			qlt81nvr->ext_blk.version[0] = 1;
 /*
  * not yet, for !FIP firmware at least
@@ -1388,7 +2324,7 @@
 		}
 
 		bctl = (qlt_dmem_bctl_t *)mcp->dbuf->db_port_private;
-		da = bctl->bctl_dev_addr + 0x80; /* base addr of eicb (phys) */
+		da = bctl->bctl_dev_addr + 0xA0; /* base addr of eicb (phys) */
 
 		mcp->to_fw[11] = LSW(LSD(da));
 		mcp->to_fw[10] = MSW(LSD(da));
@@ -1404,20 +2340,29 @@
 	}
 
 	qlt_dmem_dma_sync(mcp->dbuf, DDI_DMA_SYNC_FORDEV);
-	mcp->to_fw[0] = MBC_INITIALIZE_FIRMWARE;
+	if (((qlt->qlt_83xx_chip) || (qlt->qlt_81xx_chip) ||
+	    (qlt->qlt_27xx_chip) || ((qlt->qlt_25xx_chip) &&
+	    (qlt->qlt_mq_enabled))) && (qlt->fw_attr & BIT_6)) {
+		mcp->to_fw[0] = MBC_INITIALIZE_MULTI_ID_FW;
+	} else {
+		mcp->to_fw[0] = MBC_INITIALIZE_FIRMWARE;
+	}
 
 	/*
 	 * This is the 1st command after adapter initialize which will
 	 * use interrupts and regular mailbox interface.
 	 */
+	qlt->qlt_intr_enabled = 1;
 	qlt->mbox_io_state = MBOX_STATE_READY;
 	REG_WR32(qlt, REG_INTR_CTRL, ENABLE_RISC_INTR);
 	/* Issue mailbox to firmware */
 	ret = qlt_mailbox_command(qlt, mcp);
 	if (ret != QLT_SUCCESS) {
-		EL(qlt, "qlt_mailbox_command=60h status=%llxh\n", ret);
+		EL(qlt, "qlt_mbox_command=48h/60h status=%llxh\n", ret);
 		cmn_err(CE_NOTE, "qlt(%d) init fw failed %llx, intr status %x",
 		    instance, (long long)ret, REG_RD32(qlt, REG_INTR_STATUS));
+		qlt_free_mailbox_command(qlt, mcp);
+		return (ret);
 	}
 
 	mcp->to_fw_mask = BIT_0;
@@ -1425,19 +2370,99 @@
 	mcp->to_fw[0] = 0x28;
 	ret = qlt_mailbox_command(qlt, mcp);
 	if (ret != QLT_SUCCESS) {
-		EL(qlt, "qlt_mailbox_command=28h status=%llxh\n", ret);
+		EL(qlt, "qlt_mbox_command=28h status=%llxh\n", ret);
 		cmn_err(CE_NOTE, "qlt(%d) get_fw_options %llx", instance,
 		    (long long)ret);
+		qlt_free_mailbox_command(qlt, mcp);
+		return (ret);
 	}
 
+	if (qlt->qlt_mq_enabled == 1) {
+
+		for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+			da = qlt->mq_resp[i].queue_mem_mq_cookie.dmac_laddress;
+
+			mcp->to_fw_mask = BIT_14 | BIT_13 | BIT_12 | BIT_11 |
+			    BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 |
+			    BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0;
+			mcp->from_fw_mask = BIT_0 | BIT_1;
+
+			/* msix vector setup */
+			mcp->to_fw[14] = (uint16_t)(i);
+
+			mcp->to_fw[13] = 0;
+			mcp->to_fw[12] = 0;
+			mcp->to_fw[11] = 0;
+			mcp->to_fw[10] = 0;
+			mcp->to_fw[9] = 0;
+			mcp->to_fw[8] = 0;
+			mcp->to_fw[7] = LSW(MSD(da));
+			mcp->to_fw[6] = MSW(MSD(da));
+			mcp->to_fw[5] = RESPONSE_QUEUE_MQ_ENTRIES;
+			mcp->to_fw[4] = (uint16_t)(i);
+			mcp->to_fw[3] = LSW(LSD(da));
+			mcp->to_fw[2] = MSW(LSD(da));
+			mcp->to_fw[1] = BIT_6 | BIT_1;
+			mcp->to_fw[0] = 0x1F;
+			ret = qlt_mailbox_command(qlt, mcp);
+
+			if (ret != QLT_SUCCESS) {
+				EL(qlt, "qlt_mbox_command=1fh status=%llxh\n",
+				    ret);
+				cmn_err(CE_NOTE, "qlt(%d) queue manage %llx",
+				    instance, (long long)ret);
+				qlt_free_mailbox_command(qlt, mcp);
+				return (ret);
+			}
+
+			da = qlt->mq_req[i].queue_mem_mq_cookie.dmac_laddress;
+
+			mcp->to_fw_mask = BIT_14 | BIT_13 | BIT_12 | BIT_11 |
+			    BIT_10 | BIT_9 | BIT_8 | BIT_7 | BIT_6 | BIT_5 |
+			    BIT_4 | BIT_3 | BIT_2 | BIT_1 | BIT_0;
+			mcp->from_fw_mask = BIT_0 | BIT_1;
+
+			/*
+			 * msix vector does not apply for request queue create
+			 */
+			mcp->to_fw[14] = 2;
+			mcp->to_fw[13] = 0;
+			mcp->to_fw[12] = 4;
+			mcp->to_fw[11] = 0;
+			mcp->to_fw[10] = (uint16_t)(i);
+			mcp->to_fw[9] = 0;
+			mcp->to_fw[8] = 0;
+			mcp->to_fw[7] = LSW(MSD(da));
+			mcp->to_fw[6] = MSW(MSD(da));
+			mcp->to_fw[5] = REQUEST_QUEUE_MQ_ENTRIES;
+			mcp->to_fw[4] = (uint16_t)(i);
+			mcp->to_fw[3] = LSW(LSD(da));
+			mcp->to_fw[2] = MSW(LSD(da));
+			mcp->to_fw[1] = BIT_6;
+			mcp->to_fw[0] = 0x1F;
+			ret = qlt_mailbox_command(qlt, mcp);
+
+			if (ret != QLT_SUCCESS) {
+				EL(qlt, "qlt_mbox_command=1fh status=%llxh\n",
+				    ret);
+				cmn_err(CE_NOTE, "qlt(%d) queue manage %llx",
+				    instance, (long long)ret);
+				qlt_free_mailbox_command(qlt, mcp);
+				return (ret);
+			}
+		}
+	}
+
 	/*
 	 * Report FW versions for 81xx - MPI rev is useful
 	 */
-	if (qlt->qlt_81xx_chip) {
+	/* if ((qlt->qlt_83xx_chip) || (qlt->qlt_81xx_chip)) { */
+	if (qlt->qlt_fcoe_enabled) {
 		mcp->to_fw_mask = BIT_0;
-		mcp->from_fw_mask = BIT_11 | BIT_10 | BIT_3 | BIT_2 | BIT_1 |
-		    BIT_0;
-		mcp->to_fw[0] = 0x8;
+		mcp->from_fw_mask = BIT_11 | BIT_10 | BIT_6 | BIT_3 | BIT_2 |
+		    BIT_1 | BIT_0;
+
+		mcp->to_fw[0] = MBC_ABOUT_FIRMWARE;
 		ret = qlt_mailbox_command(qlt, mcp);
 		if (ret != QLT_SUCCESS) {
 			EL(qlt, "about fw failed: %llx\n", (long long)ret);
@@ -1446,6 +2471,8 @@
 			    mcp->from_fw[1], mcp->from_fw[2], mcp->from_fw[3],
 			    mcp->from_fw[10] & 0xff, mcp->from_fw[11] >> 8,
 			    mcp->from_fw[11] & 0xff);
+			EL(qlt, "Firmware Attributes %x[h]\n",
+			    mcp->from_fw[6]);
 		}
 	}
 
@@ -1460,6 +2487,7 @@
 
 	if (ret != QLT_SUCCESS)
 		return (ret);
+
 	return (FCT_SUCCESS);
 }
 
@@ -1466,7 +2494,8 @@
 fct_status_t
 qlt_port_offline(qlt_state_t *qlt)
 {
-	int		retries;
+	int retries;
+	int i;
 
 	mutex_enter(&qlt->mbox_lock);
 
@@ -1491,9 +2520,19 @@
 poff_mbox_done:;
 	qlt->intr_sneak_counter = 10;
 	mutex_enter(&qlt->intr_lock);
+	if (qlt->qlt_mq_enabled == 1) {
+		for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+			mutex_enter(&qlt->mq_resp[i].mq_lock);
+		}
+	}
 	(void) qlt_reset_chip(qlt);
 	drv_usecwait(20);
 	qlt->intr_sneak_counter = 0;
+	if (qlt->qlt_mq_enabled == 1) {
+		for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+			mutex_exit(&qlt->mq_resp[i].mq_lock);
+		}
+	}
 	mutex_exit(&qlt->intr_lock);
 
 	return (FCT_SUCCESS);
@@ -1518,8 +2557,9 @@
 	/* Issue mailbox to firmware */
 	ret = qlt_mailbox_command(qlt, mcp);
 	if (ret != QLT_SUCCESS) {
-		EL(qlt, "qlt_mailbox_command=20h status=%llxh\n", ret);
-		if ((mcp->from_fw[0] == 0x4005) && (mcp->from_fw[1] == 7)) {
+		EL(qlt, "qlt_mbox_command=20h status=%llxh\n", ret);
+		if ((mcp->from_fw[0] == 0x4005) &&
+		    ((mcp->from_fw[1] == 7) || (mcp->from_fw[1] == 0x1b))) {
 			/* Firmware is not ready */
 			if (ddi_get_lbolt() < et) {
 				delay(drv_usectohz(50000));
@@ -1526,6 +2566,8 @@
 				goto link_info_retry;
 			}
 		}
+		EL(qlt, "GET ID mbox failed, ret=%llx mb0=%x mb1=%x",
+		    ret, mcp->from_fw[0], mcp->from_fw[1]);
 		stmf_trace(qlt->qlt_port_alias, "GET ID mbox failed, ret=%llx "
 		    "mb0=%x mb1=%x", ret, mcp->from_fw[0], mcp->from_fw[1]);
 		fc_ret = FCT_FAILURE;
@@ -1558,6 +2600,10 @@
 		}
 		qlt->cur_topology = li->port_topology;
 		fc_ret = FCT_SUCCESS;
+
+		EL(qlt, "MBC_GET_ID done, Topology=%x, portid=%xh, "
+		    "port speed=%xh\n", li->port_topology, li->portid,
+		    li->port_speed);
 	}
 	qlt_free_mailbox_command(qlt, mcp);
 
@@ -1570,7 +2616,7 @@
 		mcp->to_fw_mask |= BIT_0 | BIT_1 | BIT_9 | BIT_10;
 		fc_ret = qlt_mailbox_command(qlt, mcp);
 		if (fc_ret != QLT_SUCCESS) {
-			EL(qlt, "qlt_mailbox_command=64h status=%llxh\n",
+			EL(qlt, "qlt_mbox_command=64h status=%llxh\n",
 			    fc_ret);
 			stmf_trace(qlt->qlt_port_alias, "Attempt to get port "
 			    "database for F_port failed, ret = %llx", fc_ret);
@@ -1581,6 +2627,8 @@
 			p = mcp->dbuf->db_sglist[0].seg_addr;
 			bcopy(p + 0x18, li->port_rpwwn, 8);
 			bcopy(p + 0x20, li->port_rnwwn, 8);
+			EL(qlt, "qlt_mbox_command=64h, GET_PORT_DATABASE "
+			    "complete\n");
 		}
 		qlt_free_mailbox_command(qlt, mcp);
 	}
@@ -1695,7 +2743,7 @@
 	qlt_fw_info_t	*fwi;
 	mbox_cmd_t	*mcp;
 	fct_status_t	st;
-	char		info[QLT_INFO_LEN];
+	char		info[80];
 	fct_status_t	ret2;
 
 	if (drv_priv(credp) != 0)
@@ -1749,8 +2797,9 @@
 			iocd->stmf_error = QLTIO_NOT_ONLINE;
 			break;
 		}
-		(void) snprintf(info, sizeof (info), "qlt_ioctl: qlt-%p, "
+		(void) snprintf(info, 80, "qlt_ioctl: qlt-%p, "
 		    "user triggered FWDUMP with RFLAG_RESET", (void *)qlt);
+		info[79] = 0;
 		if ((ret2 = fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_USER_REQUEST | STMF_RFLAG_RESET |
 		    STMF_RFLAG_COLLECT_DEBUG_DUMP, info)) != FCT_SUCCESS) {
@@ -1786,6 +2835,7 @@
 		if ((qlt->qlt_81xx_chip && ((intp[8] & 8) == 0)) ||
 		    (qlt->qlt_25xx_chip && ((intp[8] & 4) == 0)) ||
 		    (!qlt->qlt_25xx_chip && !qlt->qlt_81xx_chip &&
+		    !qlt->qlt_83xx_chip && !qlt->qlt_27xx_chip &&
 		    ((intp[8] & 3) == 0))) {
 			EL(qlt, "UPLOAD_FW fw_type=%d\n", intp[8]);
 			ret = EACCES;
@@ -1845,7 +2895,18 @@
 			fwi->fwi_loaded_subminor = (uint16_t)qlt->fw_code01[6];
 			fwi->fwi_loaded_attr = (uint16_t)qlt->fw_code01[7];
 		}
-		if (qlt->qlt_81xx_chip) {
+		if (qlt->qlt_27xx_chip) {
+			fwi->fwi_default_major = (uint16_t)fw2700_code01[4];
+			fwi->fwi_default_minor = (uint16_t)fw2700_code01[5];
+			fwi->fwi_default_subminor = (uint16_t)fw2700_code01[6];
+			fwi->fwi_default_attr = (uint16_t)fw2700_code01[7];
+		} else if (qlt->qlt_83xx_chip) {
+			fwi->fwi_default_major = (uint16_t)fw8300fc_code01[4];
+			fwi->fwi_default_minor = (uint16_t)fw8300fc_code01[5];
+			fwi->fwi_default_subminor =
+			    (uint16_t)fw8300fc_code01[6];
+			fwi->fwi_default_attr = (uint16_t)fw8300fc_code01[7];
+		} else if (qlt->qlt_81xx_chip) {
 			fwi->fwi_default_major = (uint16_t)fw8100_code01[4];
 			fwi->fwi_default_minor = (uint16_t)fw8100_code01[5];
 			fwi->fwi_default_subminor = (uint16_t)fw8100_code01[6];
@@ -1920,7 +2981,7 @@
 		break;
 
 	case QLT_IOCTL_ELOG:
-		qlt_dump_el_trace_buffer(qlt);
+		EL(qlt, "Not support yet, ioctl-%xh\n", cmd);
 		break;
 
 	default:
@@ -1952,15 +3013,19 @@
 	fct_status_t	 rval;
 
 	mcp = qlt_alloc_mailbox_command(qlt, 0);
-	mcp->to_fw[0] = 0x0072;
-	mcp->to_fw[1] = BIT_4;
-	mcp->to_fw[3] = 1;
-	mcp->to_fw_mask |= BIT_1 | BIT_3;
+	if (qlt->qlt_fcoe_enabled) {
+		mcp->to_fw[0] = MBC_PORT_RESET;
+	} else {
+		mcp->to_fw[0] = MBC_LIP_FULL_LOGIN;
+		mcp->to_fw[1] = BIT_4;
+		mcp->to_fw[3] = 1;
+		mcp->to_fw_mask |= BIT_1 | BIT_3;
+	}
 	rval = qlt_mailbox_command(qlt, mcp);
 	if (rval != FCT_SUCCESS) {
-		EL(qlt, "qlt force lip MB failed: rval=%x", rval);
+		EL(qlt, "qlt force lip MB failed: rval=%x\n", rval);
 	} else {
-		if (mcp->from_fw[0] != 0x4000) {
+		if (mcp->from_fw[0] != QLT_MBX_CMD_SUCCESS) {
 			QLT_LOG(qlt->qlt_port_alias, "qlt FLIP: fw[0]=%x",
 			    mcp->from_fw[0]);
 			rval = FCT_FAILURE;
@@ -1988,6 +3053,9 @@
 	st.st_completion_status = FCT_SUCCESS;
 	st.st_additional_info = NULL;
 
+	EL(qlt, "port (%p) qlt_state (%xh) cmd (%xh) arg (%p)\n",
+	    port, qlt->qlt_state, cmd, arg);
+
 	switch (cmd) {
 	case FCT_CMD_PORT_ONLINE:
 		if (qlt->qlt_state == FCT_STATE_ONLINE)
@@ -2061,17 +3129,19 @@
 		break;
 
 	case FCT_CMD_FORCE_LIP:
-		if (qlt->qlt_81xx_chip) {
+		if (qlt->qlt_fcoe_enabled) {
 			EL(qlt, "force lip is an unsupported command "
 			    "for this adapter type\n");
 		} else {
-			*((fct_status_t *)arg) = qlt_force_lip(qlt);
-			EL(qlt, "forcelip done\n");
+			if (qlt->qlt_state == FCT_STATE_ONLINE) {
+				*((fct_status_t *)arg) = qlt_force_lip(qlt);
+				EL(qlt, "forcelip done\n");
+			}
 		}
 		break;
 
 	default:
-		EL(qlt, "unsupport cmd - 0x%02X", cmd);
+		EL(qlt, "unsupport cmd - 0x%02X\n", cmd);
 		break;
 	}
 }
@@ -2095,23 +3165,44 @@
  * **CALL qlt_submit_req_entries() BEFORE DROPPING THE LOCK**
  */
 caddr_t
-qlt_get_req_entries(qlt_state_t *qlt, uint32_t n)
+qlt_get_req_entries(qlt_state_t *qlt, uint32_t n, uint16_t qi)
 {
 	int try = 0;
 
-	while (qlt->req_available < n) {
+	while (qlt->mq_req[qi].mq_available < n) {
 		uint32_t val1, val2, val3;
-		val1 = REG_RD32(qlt, REG_REQ_OUT_PTR);
-		val2 = REG_RD32(qlt, REG_REQ_OUT_PTR);
-		val3 = REG_RD32(qlt, REG_REQ_OUT_PTR);
+
+		if (qlt->qlt_mq_enabled) {
+			/* debounce */
+			val1 = MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_REQ_OUT);
+			val2 = MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_REQ_OUT);
+			val3 = MQBAR_RD32(qlt,
+			    (qi * MQBAR_REG_OFFSET) + MQBAR_REQ_OUT);
+		} else {
+			val1 = REG_RD32(qlt, REG_REQ_OUT_PTR);
+			val2 = REG_RD32(qlt, REG_REQ_OUT_PTR);
+			val3 = REG_RD32(qlt, REG_REQ_OUT_PTR);
+		}
 		if ((val1 != val2) || (val2 != val3))
 			continue;
 
-		qlt->req_ndx_from_fw = val1;
-		qlt->req_available = REQUEST_QUEUE_ENTRIES - 1 -
-		    ((qlt->req_ndx_to_fw - qlt->req_ndx_from_fw) &
-		    (REQUEST_QUEUE_ENTRIES - 1));
-		if (qlt->req_available < n) {
+		qlt->mq_req[qi].mq_ndx_from_fw = val1;
+		if (qi != 0) {
+			qlt->mq_req[qi].mq_available =
+			    REQUEST_QUEUE_MQ_ENTRIES - 1 -
+			    ((qlt->mq_req[qi].mq_ndx_to_fw -
+			    qlt->mq_req[qi].mq_ndx_from_fw) &
+			    (REQUEST_QUEUE_MQ_ENTRIES - 1));
+		} else {
+			qlt->mq_req[qi].mq_available =
+			    REQUEST_QUEUE_ENTRIES - 1 -
+			    ((qlt->mq_req[qi].mq_ndx_to_fw -
+			    qlt->mq_req[qi].mq_ndx_from_fw) &
+			    (REQUEST_QUEUE_ENTRIES - 1));
+		}
+		if (qlt->mq_req[qi].mq_available < n) {
 			if (try < 2) {
 				drv_usecwait(100);
 				try++;
@@ -2118,7 +3209,11 @@
 				continue;
 			} else {
 				stmf_trace(qlt->qlt_port_alias,
-				    "Req Q is full");
+				    "Req Q# %xh is full", qi);
+				EL(qlt, "Req %xh is full (%d,%d) (%d,%d)\n",
+				    qi, qlt->mq_req[qi].mq_ndx_to_fw,
+				    qlt->mq_req[qi].mq_ndx_from_fw,
+				    n, qlt->mq_req[qi].mq_available);
 				return (NULL);
 			}
 		}
@@ -2125,7 +3220,7 @@
 		break;
 	}
 	/* We dont change anything until the entries are sumitted */
-	return (&qlt->req_ptr[qlt->req_ndx_to_fw << 6]);
+	return (&qlt->mq_req[qi].mq_ptr[qlt->mq_req[qi].mq_ndx_to_fw << 6]);
 }
 
 /*
